﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SuperListEx
{
    /// <summary>
    /// Details of data changed event args
    /// </summary>
    public class ColumnDataChangedEventArgs : EventArgs
    {
        internal ColumnDataChangedEventArgs(Column column, WhatPropertyChanged whatChanged)
        {
            WhatChanged = whatChanged;
            Column = column;
        }

        /// <summary>
        /// The Column who's data changed
        /// </summary>
        public readonly Column Column;

        /// <summary>
        /// The property that caused the change event.
        /// </summary>
        public readonly WhatPropertyChanged WhatChanged;
    }
}
