﻿using System.Drawing;
using System.Windows.Forms;
using SuperListEx.Utility.Collections;
using SuperListEx.Sections;

namespace SuperListEx
{
    public class AvailableColumnSection : HeaderColumnSection
    {
        #region constructors
        public AvailableColumnSection(ISectionHost host, Column column)
            : base(host, DisplayMode.Customise, column)
        {
        }
        #endregion

        #region public functions
        public override void MouseUp(MouseEventArgs e)
        {
        }

        public override void Layout(GraphicsSettings gs, Size maximumSize)
        {
            base.Layout(gs, maximumSize);
            Size = new Size(maximumSize.Width, Size.Height);
        }
        #endregion

        #region protected functions
        protected override TextFormatFlags GetTextFormatFlags()
        {
            return TextFormatFlags.VerticalCenter | TextFormatFlags.HorizontalCenter | TextFormatFlags.EndEllipsis;
        }

        protected override void DrawSortArrow(GraphicsSettings gs, Rectangle rc)
        {
            // do nothing.
        }
        #endregion
    }
}
