﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ExcelExportLib
{
    /// <summary>Type of data in the cell</summary>
    public enum eCellType
    {
        /// <summary>Date only</summary>
        Date,
        /// <summary>Date and Time</summary>
        DateTime,
        /// <summary>Time only</summary>
        Time,
        /// <summary>String</summary>
        String,
        /// <summary>Number</summary>
        Number,
        /// <summary>Percent</summary>
        Percent,
        /// <summary>Hyperlink</summary>
        HyperLink,
        Formula,
    }

    /// <summary>DateTime format</summary>
    public enum eDateType
    {
        /// <summary>Date only</summary>
        Date,
        /// <summary>Date and Time</summary>
        DateTime,
        /// <summary>Time only</summary>
        Time,
    }

    /// <summary>Vertical Alignment of text in cell</summary>
    public enum eVerticalAlignment
    {
        Automatic,
        Bottom,
        Top,
        Center,
        Justify,
        Distributed,
        JustifyDistributed    
    }

    /// <summary>Horizontal Alignment of text in cell</summary>
    public enum eHorizontalAlignment
    {
        Automatic,
        Right,
        Left,
        Center,
        Fill,
        Justify,
        CenterAcrossSelection,
        Distributed,
        JustifyDistributed
    }
    /// <summary>Border position of the cell</summary>
    public enum eBorderPosition
    { 
        Left,
        Top,
        Right,
        Bottom,
        None
    }
    /// <summary>Border style of the cell</summary>
    public enum eBorderStyle
    {
        None,
        Continuous, 
        Dash,
        Dot, 
        DashDot, 
        DashDotDot
    }

    /// <summary>Border weight (or thickness) of the cell</summary>
    public enum eBorderWeight : byte 
    {
        Hairline = 0,
        Thin = 1,
        Medium = 2,
        Thick = 3,
    }

    public enum eBackgroundPattern
    {
        None,
        Solid,
        Gray75,
        Gray50,
        Gray25,
        Gray125,
        Gray0625,
        HorzStripe,
        VertStripe,
        ReverseDiagStripe,
        DiagStripe, 
        DiagCross, 
        ThickDiagCross, 
        ThinHorzStripe, 
        ThinVertStripe, 
        ThinReverseDiagStripe, 
        ThinDiagStripe, 
        ThinHorzCross,
        ThinDiagCross
    }
    public enum eFontUnderline
    {
        None,
        Single,
        Double,
        SingleAccounting,
        DoubleAccounting
    }
    public enum eFontVerticalAlign
    {
        None,
        Subscript,
        Superscript
    }
    public enum eFontFamily
    {
        Automatic,
        Decorative,
        Modern, 
        Roman, 
        Script,
        Swiss
    }
}
